#include <stdio.h>
/* fatt.c : file sorgente di un programma che calcola in modo
            ricorsivo il fattoriale di un dato numero intero */
/* ### */
/* La prossima definizione consente di cambiare facilmente il
   coefficiente intero n massimo di cui calcoliamo il fattoriale
   n!
   Nota: Si tenga presente che 13! e' maggiore del numero massimo
         rappresentabile con il tipo int. Ovviamente, si puo'
	 cambiare il programma in modo che il calcolo venga fatto
         con il tipo long int o unsigned long int */
#define NMAX 12
/* Definizione dei prototipi delle funzioni */
int fatt(int n);
/* ### */
int main()
{
  /* Definizione delle variabili:
     n = coefficiente intero
     nfat = intero contenente il risultato di n! */
  int n, nfat;
  /* Fase di input del coefficiente intero n */
  do {
    printf("Dammi un numero non negativo (<=%d): ", NMAX);
    scanf("%d", &n);
  } while (n < 0  ||  n > NMAX);
  /* Calcoliamo ris = n! */
  nfat = fatt(n);
  /* Stampiamo "  n! = nfat " */
  printf("  %d! = %d\n", n, nfat);
  exit(0);
}
/* ### */
int fatt(n)
     int n;
    /* Nota: questa function e' stata scritta in modo tale che
             il calcolo di n! sia ricorsivo */
{
  /* Definizione dell'intero che contiene il risultato */
  int ris;
  /* Scriviamo un messaggio di entrata nella funzione */
  printf("Chiamata della funzione fatt per n = %d\n", n);
  /* Test di fine ricorsione: n e' uguale a 0? */
  if(n == 0) {
    /* Quando n=0, dobbiamo semplicemente porre ris = 1 */
    ris = 1;
  }
  else {
    /* Quando n>0, calcoliamo ricorsivamente ris = n * fatt(n-1) */
    ris = n * fatt(n-1);
  }
  /* Scriviamo un messaggio di uscita dalla funzione */
  printf("Uscita della funzione fatt per n = %d\n", n);
  /* Uscita dalla funzione con restituzione del risultato al modulo
     chiamante */
  return(ris);
}
