#include <stdio.h>
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima dei nomi e dei cognomi */
#define LUNGMAX 25
/* ### */
void elimina_trattino(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere ' ' al posto di ogni
	      carattere '_' nella stringa scritta.
	      Esempio: 'Giovanni_Battista' deve diventare
	      'Giovanni Battista' al termine della function. */
{
  char *puntatore;
  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */
  puntatore = strchr(scritta, '_');
  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */
  while(puntatore != NULL) {
    /* Poniamo uguale allo spazio il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore */
    *puntatore = ' ';
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
    puntatore++;
    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore:
       assegnamo ancora alla variabile puntatore l'indirizzo di memoria
       corrispondente (conviene utilizzare la funzione strchr) */
    puntatore = strchr(puntatore, '_');
  }
  /* Uscita dalla funzione */
  return;
}
/* ### */
void maiusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */
  for(i=0; i<strlen(scritta); i++) {
    /* Se scritta[i] e' una lettera minuscola, mettiamo la maiuscola al
       suo posto, utilizzando la funzione toupper */
    scritta[i] = toupper(scritta[i]);
  }
}
/* ### */
void minusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */
  for(i=0; i<strlen(scritta); i++) {
    /* Se scritta[i] e' una lettera maiuscola, mettiamo la minuscola al
       suo posto, utilizzando la funzione tolower */
    scritta[i] = tolower(scritta[i]);
  }
}
/* ### */
void riempi_di_spazi(scritta)
     char scritta[];
{
  int i;
  /* Ciclo su i che va dalla lunghezza di scritta (conviene utilizzare
     la funzione strlen) a LUNGMAX-2 */
  for(i=strlen(scritta); i<LUNGMAX-1; i++) {
    /* Poniamo l'i-esimo carattere di scritta uguale a Space (=' ') */
    scritta[i] = ' ';
  }
  /* Poniamo l'ultimo carattere di scritta (cioe' quello di posto
     LUNGMAX-1) uguale a NUL */
  scritta[LUNGMAX-1] = 0;
}
/* ### */
void trattino_maiusc(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere maiuscolo al posto del
	      minuscolo all'inizio della scritta e dopo ogni carattere '_'.
	      Esempio: 'giovanni_battista' deve diventare
	      'Giovanni_Battista' al termine della function. */
{
  char *puntatore;
  /* Facciamo diventare maiuscolo il primo carattere di scritta,
     utilizzando la funzione toupper */
  scritta[0] = toupper(scritta[0]);
  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */
  puntatore = strchr(scritta, '_');
  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */
  while(puntatore != NULL) {
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
    puntatore++;
    /* Facciamo diventare maiuscolo il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore
       (conviene utilizzare la funzione toupper) */
    *puntatore = toupper(*puntatore);
    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore: assegnamo ancora alla variabile
       puntatore l'indirizzo di memoria corrispondente (conviene
       utilizzare la funzione strchr) */
    puntatore = strchr(puntatore, '_');
  }
  /* Uscita dalla funzione */
  return;
}
