#include <stdio.h>
/* riscrivi_elenco.c : file sorgente di un programma che legge l'elenco
                       degli studenti (con il loro login name e il gruppo
		       di appartenenza) dal file "elenco.dat".
		       Dopo aver effettuato alcune
		       manipolazioni sulle stringhe formate da un nome e
		       da un cognome, l'elenco viene riscritto in un formato
		       (sperabilmente) piu' ordinato nel file "belenco.dat". */
/* ### */
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima dei nomi e dei cognomi */
#define LUNGMAX 25
/* Per definire i prototipi delle funzioni includo il file libreria.h */
#include "libreria.h"
/* ### */
int main()
{
  int i;
  int lung;
  char scrittainiz[2*LUNGMAX], scrittafin[3*LUNGMAX];
  char nome[LUNGMAX], cognome[LUNGMAX];
  char *puntatore;
  FILE *ifp, *ofp;
  /* Apriamo il file di input "elenco.dat" in lettura,
     associamo a ifp l'indirizzo corrispondente al file */
  ifp = fopen("elenco.dat", "r");
  /* Apriamo il file di output "belelenco.dat" in scrittura,
     associamo a ofp l'indirizzo corrispondente al file */
  ofp = fopen("belelenco.dat", "w");
  /* Inizio delle scritture di intestazione in cima al file di output */
  /* Scriviamo "Login:" nel file di output */
  fprintf(ofp, "Login:");
  /* Scriviamo 4 spazi nel file di output (per distanziare bene cio' che
     si trova in testa al file) */
  for(i=0; i<4; i++)
    fprintf(ofp, " ");
  /* Scriviamo "Cognome:" nel file di output */
  fprintf(ofp, "Cognome:");
  /* Scriviamo LUNGMAX-9 spazi nel file di output (per distanziare bene
     cio' che si trova in testa al file) */
  for(i=0; i<LUNGMAX-9; i++)
    fprintf(ofp, " ");
  /* Scriviamo "Nome:" nel file di output */
  fprintf(ofp, "Nome:");
  /* Scriviamo LUNGMAX-6 spazi nel file di output (per distanziare bene
     cio' che si trova in testa al file) */
  for(i=0; i<LUNGMAX-6; i++)
    fprintf(ofp, " ");
  /* Scriviamo "Gruppo:" e andiamo a capo nel file di output */
  fprintf(ofp, "Gruppo:\n");
  /* Fine delle scritture di intestazione in cima al file di output */
  /* Leggiamo una riga del file di input e la scriviamo nella
     stringa scrittafin utilizzando l'istruzione fgets.
     Questa istruzione di lettura la mettiamo all'interno di
     una condizione di esecuzione di un ciclo while(...) {...}.
     Continuiamo ad eseguire il ciclo, mentre e' verificata la condizione
     che il risultato restituito da fgets sia diverso da NULL */
  while( fgets(scrittafin, 10, ifp) != NULL) {
    /* Assegnamo alla variabile lung la lunghezza della stringa
       scrittafin (conviene utilizzare la funzione strlen) */
    lung = strlen(scrittafin);
    /* L'ultimo carattere di scrittafin e' un LF (=va alla riga
       successiva), e' meglio eliminarlo ponendo uno 0 (cioe' il
       carattere NUL) al suo posto;
       si ricordi che il carattere LF e' in scrittafin[lung-1] */
    scrittafin[lung-1] = 0;
    /* Scriviamo in coda alla stringa scrittafin 3 spazi (in modo
       da distanziare bene cio' che scriviamo sul file di output):
       e' conveniente utilizzare l'istruzione strcat */
    strcat(scrittafin, "   ");
    /* Leggiamo una riga dal file di input e la scriviamo nella stringa
       scrittainiz (essa sara' composta da un nome e da un cognome)
       utilizzando l'istruzione fgets */
    fgets(scrittainiz, 2*LUNGMAX, ifp);
    /* Assegnamo alla variabile lung la lunghezza della stringa
       scrittainiz (conviene utilizzare la funzione strlen) */
    lung = strlen(scrittainiz);
    /* L'ultimo carattere di scrittainiz e' un LF (=va alla riga
       successiva), e' meglio eliminarlo ponendo uno 0 (cioe' il
       carattere NUL) al suo posto;
       si ricordi che il carattere LF e' in scrittainiz[lung-1] */
    scrittainiz[lung-1] = 0;
    /* Troviamo l'indirizzo di memoria corrispondente al carattere ' '
       che separa il nome dal cognome:
       assegnamo alla variabile puntatore l'indirizzo di memoria
       corrispondente (conviene utilizzare la funzione strchr) */
    puntatore = strchr(scrittainiz, ' ');
    /* Poniamo uguale a 0 (cioe' il carattere NUL) il valore del
       carattere che si trova nell'indirizzo di memoria a cui si
       riferisce puntatore */
    *puntatore = 0;
    /* Copiamo nella stringa cognome la parte di stringa contenuta in
       scrittainiz fino al primo carattere NUL (conviene utilizzare la
       funzione strcpy) */
    strcpy(cognome, scrittainiz);
    /* Riempiamo la stringa cognome con degli spazi */
    riempi_di_spazi(cognome);
    /* Facciamo diventare maiuscole tutte le lettere del cognome */
    maiusc(cognome);
    /* Copiamo il cognome in coda alla stringa scrittafin (conviene
       utilizzare la funzione strcat) */
    strcat(scrittafin, cognome);
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
    puntatore++;
    /* Copiamo nella stringa nome la parte di stringa contenuta in
       scrittainiz a partire dall'indirizzo di memoria in puntatore
       fino al secondo carattere NUL (conviene utilizzare la funzione
       strcpy) */
    strcpy(nome, puntatore);
    /* Riempiamo la stringa nome con degli spazi */
    riempi_di_spazi(nome);
    /* Facciamo diventare minuscole tutte le lettere del nome */
    minusc(nome);
    /* Mettiamo le maiuscole alla prima lettera del nome e ad ogni lettera
       che segue un trattino del tipo '_' */
    trattino_maiusc(nome);
    /* Copiamo il nome in coda alla stringa scrittafin (conviene utilizzare
       la funzione strcat) */
    strcat(scrittafin, nome);
    /* Sostituisco tutti i trattini che compaiono nella stringa scrittafin
       con degli spazi */
    elimina_trattino(scrittafin);
    /* Leggiamo una riga dal file di input e la scriviamo nella stringa
       scrittainiz (essa sara' composta dalla lettera del gruppo)
       utilizzando l'istruzione fgets */
    fgets(scrittainiz, 10, ifp);
    /* Copiamo la stringa scrittainiz in coda alla stringa scrittafin
       (conviene utilizzare la funzione strcat) */
    strcat(scrittafin, scrittainiz);
    /* Scriviamo sul file di output la stringa scrittafin */
    fprintf(ofp, "%s", scrittafin);
  }
  /* Chiudiamo il file di input */
  fclose(ifp);
  /* Chiudiamo il file di output */
  fclose(ofp);
  exit(0);
}
